/******************************************************************************
*
* interrupts.c
*
* Interrupts module (ARM mode only).
* 
* Autor: Marisz Janiak
*
* Wroclaw 2006
*
******************************************************************************/

#define __EXTERN_

#include "LPC214x.h"
#include "Globals.h"
#include "interrupts.h"
#include "functions_arm.h"
#ifdef THUMB_INTERWORK
#include "functions_thumb.h"
#endif

void FIQ_int(void)  
{

}

void UNDEF_int(void) 
{

}

void PABT_int(void) 
{

}

void DABT_int(void) 
{

}

/*

void SWI_int(void)  
{

}

void IRQ_int (void)
{
  
}
*/

void SWI_sysCall(unsigned sysCallId)
/* One function for all sys calls*/
{
  switch(sysCallId)
  {
    case 0:
      /* Write your code here for syscall id = 0 */
    break;
    case 1:
      /* Write your code here for syscall id = 1 */
    break;
    case 2:
      /* Write your code here for syscall id = 2 */
    break;
        /*
         * ...
         * 
         */
    default:
      /* Write your code here for undefined syscall id */
    break;
  } 
}

static inline unsigned __get_cpsr(void)
{
  unsigned long retval;
  asm volatile (" mrs  %0, cpsr" : "=r" (retval) : /* no inputs */  );
  return retval;
}

static inline void __set_cpsr(unsigned val)
{
  asm volatile (" msr  cpsr, %0" : /* no outputs */ : "r" (val)  );
}

unsigned disableIRQ(void)
{
  unsigned _cpsr;

  _cpsr = __get_cpsr();
  __set_cpsr(_cpsr | IRQ_MASK);
  return _cpsr;
}

unsigned restoreIRQ(unsigned oldCPSR)
{
  unsigned _cpsr;

  _cpsr = __get_cpsr();
  __set_cpsr((_cpsr & ~IRQ_MASK) | (oldCPSR & IRQ_MASK));
  return _cpsr;
}

unsigned enableIRQ(void)
{
  unsigned _cpsr;

  _cpsr = __get_cpsr();
  __set_cpsr(_cpsr & ~IRQ_MASK);
  return _cpsr;
}

unsigned disableFIQ(void)
{
  unsigned _cpsr;

  _cpsr = __get_cpsr();
  __set_cpsr(_cpsr | FIQ_MASK);
  return _cpsr;
}

unsigned restoreFIQ(unsigned oldCPSR)
{
  unsigned _cpsr;

  _cpsr = __get_cpsr();
  __set_cpsr((_cpsr & ~FIQ_MASK) | (oldCPSR & FIQ_MASK));
  return _cpsr;
}

unsigned enableFIQ(void)
{
  unsigned _cpsr;

  _cpsr = __get_cpsr();
  __set_cpsr(_cpsr & ~FIQ_MASK);
  return _cpsr;
}

/*End file interrupts.c*/



