/******************************************************************************
*
* interrupts.h
*
* Interrupts module.
* 
* Autor: Marisz Janiak
*
* Wroclaw 2006
*
******************************************************************************/

#ifndef _ARM_INTERRUPTS_
#define _ARM_INTERRUPTS_

  /* Constants and definitions */
#define IRQ_MASK 0x00000080
#define FIQ_MASK 0x00000040
#define INT_MASK (IRQ_MASK | FIQ_MASK)

#define sysCall(id) asm ("swi %0" : /*no output*/ : "i" (id))
              /* call system function, 
               *  id = [0...0xFF]     for THUMB mode,
               *  id = [0...0xFFFFFF] for ARM mode. */
                                   
  /* Interrupt handler prototypes */
void FIQ_int(void)   __attribute__ ((interrupt("FIQ")));
void UNDEF_int(void) __attribute__ ((interrupt("UNDEF")));
void PABT_int(void)  __attribute__ ((interrupt("ABORT")));
void DABT_int(void)  __attribute__ ((interrupt("ABORT")));
/*void SWI_int(void)   __attribute__ ((interrupt("SWI")));  */
/*void IRQ_int(void)   __attribute__ ((interrupt("IRQ"))); */

  /* Functions called by interrupt hendlers */
void SWI_sysCall(unsigned);           /* One function for all sys calls*/

  /* Other function prototypes*/
unsigned disableIRQ(void);
unsigned enableIRQ(void);
unsigned restoreIRQ(unsigned oldCPSR);
unsigned disableFIQ(void);
unsigned enableFIQ(void);
unsigned restoreFIQ(unsigned oldCPSR);

#endif /*End _ARM_INTERRUPTS_*/
